// ClientDCOM.cpp : dfinit le point d'entre pour l'application console.
//

#include "stdafx.h"

void AfficheErreur(HRESULT hRes)
{
	wchar_t *wszMsg;
	if (FormatMessageW(FORMAT_MESSAGE_ALLOCATE_BUFFER | 
			FORMAT_MESSAGE_FROM_SYSTEM | 
			FORMAT_MESSAGE_IGNORE_INSERTS,
			NULL, hRes,
			MAKELANGID(LANG_NEUTRAL, SUBLANG_DEFAULT),
			(LPWSTR) &wszMsg, 0, NULL))
	{
		std::wcout << wszMsg << std::endl;
		LocalFree(wszMsg);
	}
	else
		std::wcout << L"Erreur inconnue" << std::endl;
}

int _tmain(int argc, _TCHAR* argv[])
{
	HRESULT hRes = CoInitialize(NULL);
	if (SUCCEEDED(hRes))
	{
		CLSID clsidServer;
		hRes = CLSIDFromProgID(L"ServeurDCOM.Maths.1", &clsidServer);
		if (SUCCEEDED(hRes))
		{
			COSERVERINFO ServerInfo;
			memset(&ServerInfo, 0, sizeof(ServerInfo));
			std::wcout << L"Addresse du serveur : ";
			std::wstring wsAddress;
			std::getline(std::wcin, wsAddress);
			ServerInfo.pwszName = (LPWSTR) wsAddress.c_str();
			MULTI_QI itf;
			memset(&itf, 0, sizeof(itf));
			itf.pIID = &IID_IMaths;
			hRes = CoCreateInstanceEx(clsidServer, NULL, CLSCTX_REMOTE_SERVER,
				&ServerInfo, 1, &itf);
			if (SUCCEEDED(hRes))
			{
				if (SUCCEEDED(itf.hr))
				{
					IMaths *pMaths = (IMaths *) itf.pItf;
					double param1, param2;
					std::wcout << L"Premier parametre : ";
					std::wcin >> param1;
					std::wcout << L"Deuxieme parametre : ";
					std::wcin >> param2;
					double result = 0;
					hRes = pMaths->Add(param1, param2, &result);
					if (SUCCEEDED(hRes))
						std::wcout << L"Resultat : " << result << std::endl;
					else
						AfficheErreur(hRes);
					pMaths->Release();
				}
				else
					AfficheErreur(hRes);
			}
			else
				AfficheErreur(hRes);
		}
		else
			AfficheErreur(hRes);
		CoUninitialize();
	}
	else
		AfficheErreur(hRes);
	Sleep(2000);
	return 0;
}

